#define MAIN
#define uchar unsigned char
#define uint unsigned int
#define CFGSIZE 1

#include <iostream>

int main(void)
{
 uchar cfgarray[CFGSIZE];
 size_t actual_size;
 FILE *pFile;

 uint number=9; // invalid value
 
 char dummy;
 
 std::cout << "**********************************************\n";
 std::cout << "* Quick and dirty Hi65 configuration utility *\n";
 std::cout << "**********************************************\n\n";
 
 /* Configuration file format:
 1 byte - resolution, selected from a list
 */
 
 pFile=fopen ("hi65.cfg","rb");
 actual_size=fread((void*)cfgarray,sizeof(unsigned char),CFGSIZE,pFile);
 fclose (pFile);
 
 std::cout << "    CURRENT CONFIGURATION\n";
 std::cout << "-----------------------------\n";
 
 std::cout << "RESOLUTION ";
 switch(cfgarray[0])
 {
  case 0: std::cout << " 640 x 400 (16:10)"; break;
  case 1: std::cout << " 640 x 480 (4:3)"; break;
  case 2: std::cout << " 800 x 600 (4:3)"; break;
  case 3: std::cout << "1280 x 720 (16:9)"; break;
  case 4: std::cout << "1280 x 800 (16:10)"; break;
 }
 
 std::cout << "\n\nPress RETURN to start the configuration"; 
 
 std::cin.ignore();
 
 std::cout << "\nAVAILABLE RESOLUTIONS";
 std::cout << "\n---------------------";
 std::cout << "\nType: 0 for  640 x 400 (16:10)";
 std::cout << "\n      1 for  640 x 480 (4:3)";
 std::cout << "\n      2 for  800 x 600 (4:3)";
 std::cout << "\n      3 for 1280 x 720 (16:9)";
 std::cout << "\n      4 for 1280 x 800 (16:10)";
 std::cout << "\nThen press RETURN\n";
 while (number<0 || number >4)
 {
  std::cin >> number;
  if (number<0 || number >4)
   std::cout << "\nPlease enter a number from 0 to 4. Available resolutions are listed above.\n";
 }
 cfgarray[0]=number;
 
 pFile=fopen ("hi65.cfg","wb");
 fwrite (cfgarray,1,CFGSIZE,pFile);
 fclose (pFile);
 
 pFile=fopen ("hi65.cfg","rb");
 actual_size=fread((void*)cfgarray,sizeof(unsigned char),CFGSIZE,pFile);
 fclose (pFile);
 
 std::cout << "\n      NEW CONFIGURATION\n";
 std::cout << "-----------------------------\n";
 
 std::cout << "RESOLUTION ";
 switch(cfgarray[0])
 {
  case 0: std::cout << " 640 x 400 (16:10)"; break;
  case 1: std::cout << " 640 x 480 (4:3)"; break;
  case 2: std::cout << " 800 x 600 (4:3)"; break;
  case 3: std::cout << "1280 x 720 (16:9)"; break;
  case 4: std::cout << "1280 x 800 (16:10)"; break;
 }
 
 
 std::cout << "\n\nConfiguration complete. Press RETURN to exit the program.";
 
 std::cin.ignore();
 std::cin.get();
 
 return 0;
}
